<!DOCTYPE html>
<head>
<meta charset="utf-8" />
<title>Terminarz rozgrywek - webinspiracje.pl</title>
<script src="//ajax.googleapis.com/ajax/libs/jquery/2.1.1/jquery.min.js"></script>
<style type="text/css">
body
{
	font-family:Verdana, Geneva, sans-serif;
	font-size:16px;
	margin:2% 5%;
}
td
{
	padding:10px 20px;border:1px solid #ddd;text-align:center;
}
th
{
	padding:10px 20px;border:1px solid #ddd;text-align:left;background:#ddd;
}
.druzyny
{
	float:left;clear:both;
}
.druzyny li
{
	float:left;margin:10px;list-style-type:none;display:inline-block;padding:5px;border:1px solid #ddd;background:#eee;cursor:pointer;
}
.zaznaczony
{
	background:#06a !important;color:#fff !important;
}
.schowany
{
	display:none;
}
</style>
</head>
<body>
<h1>Losowe generowanie terminarza rozgrywek</h1>
<p>Autorem programu jest Stanisław Stadnicki (<a href="http://webinspiracje.pl" target="_blank">webinspiracje.pl</a>). Program pokazuje jak w sposób całkowicie losowy wygenerować terminarz rozgrywek w systemie jednej rundy - każdy z każdym.</p>
<?php
// program w języku PHP, dla generowania terminarza rozgrywek oraz układania kolejności spotkań w sposób losowy
// autor: Stanisław Stadnicki - www.webinspiracje.pl
// Wszelkie prawa zastrzeżone

############################
// ustawienia

// drużyny startujące w rozgrywkach, kolejność wpisania drużyn w tablicy nie ma znaczenia
$druzyny = array(
	'Euro DK Szonów',
	'TEAM Wróblin',
	'AMT Morawiec',
	'OHZ Głogówek',
	'Zawada',
	'Carmen PHU Prudnik',
	'Salve Głogówek',
	'Stapel Głogówek',
	'M&W Brukarstwo',
	'Oracze',
	'Naczęsławice',
	'Wal-Kurs Osobłoga',
	'Veolia Mauron',
	'KS Twardawa',
	'LKS Rolnik Biedrzychowice',
	'WebInspiracje Racławice Śląskie',
	'Pokrzywnica',
);
############################
// funkcje wyświetlania danych
function pokaz_druzyny($druzyny)
{
	echo '<ul class="druzyny">';
	for($i=0;$i<count($druzyny);$i++)
	{
		echo '<li data-druzyna="'.$druzyny[$i].'"><!--'.($i+1).'	-->'.$druzyny[$i].'</li>';
	}
	echo '<li class="all">Pokaż cały terminarz</li>';
	echo '</ul>';
	?>
    <script>
	$('.druzyny li').bind('click',function(){
		$('tr').removeClass('schowany');
		var nazwa = $(this).attr('data-druzyna');
		$('tbody tr:contains("'+nazwa+'")').each(function(index, element) {
            $(this).addClass('zaznaczony');
        });
		$('tbody tr:not(:contains("'+nazwa+'"))').each(function(index, element) {
            $(this).addClass('schowany');
        });
	});
	$('.all').bind('click',function(){
		$('tr').removeClass('schowany');
		$('tr').removeClass('zaznaczony');
	});
	</script>
	<?php
}
function znajdz_pauzujaca_druzyne($kolejka,$druzyny)
{
	for($j=0;$j<count($kolejka);$j++)
	{
		$druzyny_w_kolejce[] = $kolejka[$j]['gospodarz'];
		$druzyny_w_kolejce[] = $kolejka[$j]['gosc'];
	}
	sort($druzyny);
	sort($druzyny_w_kolejce);
	$brakujaca_druzyna = array_diff($druzyny,$druzyny_w_kolejce);
	$klucz_brakujacej_druzyny = array_keys($brakujaca_druzyna);
	return $brakujaca_druzyna[$klucz_brakujacej_druzyny[0]];
}
function pokaz_terminarz($liczba_kolejek,$liczba_druzyn,$terminarz,$druzyny)
{
	echo '<table>';
	for($i=0;$i<$liczba_kolejek;$i++)
	{
		echo '<thead>';
		echo '<tr>';
		echo '<th colspan="3">Kolejka: '.($i+1).' - data: </th>';
		echo '<th>Godzina: </th>';
		echo '</tr>';
		echo '</thead>';
		echo '<tbody>';
		$godzina = strtotime('2014-11-28 18:30:00');// w praktyce data nie ma znaczenia - chodzi o godzinę rozpoczęcia kolejki
		for($j=0;$j<count($terminarz[$i]);$j++)
		{
			echo '<tr>';
			echo '<td>'.$terminarz[$i][$j]['gospodarz'].'</td>';
			echo '<td>-</td>';
			echo '<td>'.$terminarz[$i][$j]['gosc'].'</td>';
			echo '<td>'.date("H:i:s",$godzina).'</td>';
			echo '</tr>';
			$godzina+=(30*60);//+30 minut
		}
		if($liczba_druzyn % 2 != 0)
		{
			echo '<tr>';
			echo '<td colspan="4">Pauza: '.znajdz_pauzujaca_druzyne($terminarz[$i],$druzyny).'</td>';
			echo '</tr>';
		}
		echo '</tbody>';
	}
	echo '</table>';
}

############################
// program

$liczba_druzyn = count($druzyny);

// randomizacja tablicy drużyn, wymieszanie drużyn
shuffle ($druzyny);

// n = liczba drużyn
// dla parzystego n drużyn liczba kolejek wynosi n-1
// dla nieparzystego n drużyn liczba kolejek wynosi n (zawsze jedna drużyna pauzuje)
if($liczba_druzyn % 2 ==0)
{	
	$liczba_kolejek = $liczba_druzyn - 1;
}
else
{	
	$liczba_kolejek = $liczba_druzyn;
}

// tworzenie grafu drużyn na podstawie algorytmu opisanego w:
// http://nrich.maths.org/1443
for($i=0;$i<$liczba_druzyn;$i++)
{
	$graf[$i] = $i;
}

for($i=0;$i<$liczba_kolejek;$i++)
{
	// przestawianie grafu
	// w przypadku parzystej liczby drużyn z grafu nie zdejmuje się ostatniego elementu / porusza się pozostałymi
	if($liczba_druzyn % 2 == 0)
	{
		$ostatni = $graf[count($graf)-2];
		for($j=count($graf)-2;$j>=1;$j--)
		{
			$graf[$j] = $graf[$j-1];
		}
	}
	else
	{
		$ostatni = $graf[count($graf)-1];
		for($j=count($graf)-1;$j>=1;$j--)
		{
			$graf[$j] = $graf[$j-1];
		}
	}
	$graf[0] = $ostatni; // nie ma znaczenia, czy parzysta czy nieparzysta liczba drużyn, zdjęty z końca tablicy element wstawiamy na początek
	for($j=0;$j<floor($liczba_druzyn/2);$j++)
	{
		//$terminarz[$i][] = $druzyny[$graf[$j]].' '.$j.'- '.($liczba_druzyn-$j-1).' '.$druzyny[$graf[$liczba_druzyn-$j-1]];
		$terminarz[$i][$j]['gospodarz'] = $druzyny[$graf[$j]];
		$terminarz[$i][$j]['gosc'] 		= $druzyny[$graf[$liczba_druzyn-$j-1]];
	}
}
############################
############################

pokaz_druzyny($druzyny);

echo '<h2>Terminarz:</h2>';
pokaz_terminarz($liczba_kolejek,$liczba_druzyn,$terminarz,$druzyny);
?>
</body>
</html>